/**
 * jQuery Tabs plugin 1.0.0
 *
 * @author Drfuri
 */
(function ($) {
    $.fn.motta_countdown = function () {
        return this.each(function () {
            var $this = $(this),
                diff = $this.data('expire');

            var updateClock = function (distance) {
                var weeks = Math.floor(distance / (60 * 60 * 24 *7));
                var days = Math.floor(distance / (60 * 60 * 24));
                var hours = Math.floor((distance % (60 * 60 * 24)) / (60 * 60));
                var minutes = Math.floor((distance % (60 * 60)) / (60));
                var seconds = Math.floor(distance % 60);
                var texts = $this.data('text');

                $this.html(
                    '<span class="weeks timer ' + (weeks == 0 ? 'hidden' : '') + '"><span class="digits">' + weeks + '</span><span class="text">' + texts.weeks + '</span><span class="divider">:</span></span>' +
                    '<span class="days timer ' + (days == 0 ? 'hidden' : '') + '"><span class="digits">' + days + '</span><span class="text">' + texts.days + '</span><span class="divider">:</span></span>' +
                    '<span class="hours timer"><span class="digits">' + (hours < 10 ? '0' : '') + hours + '</span><span class="text">' + texts.hours + '</span><span class="divider ' + (weeks > 0 ? 'hidden' : '') + '">:</span></span>' +
                    '<span class="minutes timer"><span class="digits">' + (minutes < 10 ? '0' : '') + minutes + '</span><span class="text">' + texts.minutes + '</span><span class="divider ' + (days > 0 ? 'hidden' : '') + '">:</span></span>' +
                    '<span class="seconds timer"><span class="digits">' + (seconds < 10 ? '0' : '') + seconds + '</span><span class="text">' + texts.seconds + '</span></span>'
                );
            };

            updateClock(diff);


            var countdown = setInterval(function () {
                diff = diff - 1;

                updateClock(diff);

                if (diff < 0) {
                    clearInterval(countdown);
                }
            }, 1000);
        });
    };

    /* Init tabs */
    $(function () {
        $('.motta-countdown').motta_countdown();

        $(document.body).on('motta_countdown', function (e, $el) {
            $el.motta_countdown();
        });
    });
})(jQuery);